#The definition of different stages of my pipeline
stages:
  - app_build
  - image_build
  - deploy
  - destroy_if_needed

#---------------------------------------------------

#Variables passed inside my jobs
variables:
    # TODO

#---------------------------------------------------
#Build angular website and produce artifact with the compilation result
#This is a template extend by specific jobs
# Need to pass Global variables during these step because Angular is compiled
frontendNG_build:
  stage: app_build
  image: # TODO
  script:
    - echo "Building Angular application and generate the artifact..."
    # TODO
  artifacts:
    paths:
    # TODO
    expire_in: 1 week
  tags:
  # TODO


#Build NodeJS website and produce artifact with the compilation result
backendMVN_build:
  stage: app_build
  image:
    name: # TODO
  script: 
    - echo "Building Spring application and generate the artifact..."
    # TODO
  artifacts:
    paths:
      # TODO
  tags:
    # TODO

#---------------------------------------------------

#Create an image with the previous artifact and Dockerfile for Angular. Publish it in the Gitlab Registry.
frontendNG_publish:
  stage: image_build
  image:
    name: # TODO
  script:
    - echo "Containerized/Publishing Angular (frontend) application"
    # TODO
  tags:
   # TODO

#Create an image with the previous artifact and Dockerfile for NodeJS. Publish it in the Gitlab Registry.
backendMVN_publish:
  stage: image_build
  image:
    name: # TODO
  script:
    - echo "Containerized/Publishing Maven (backend) application"
    # TODO
  tags:
   # TODO

#---------------------------------------------------

#Deploy application in release mode.
deploy-stage:
  stage: deploy
  image:
    name: #TODO
  variables:
    KUBE_NAMESPACE: #TODO
    KUBERNETES_SERVICE_ACCOUNT_OVERWRITE: #TODO
  script: 
    - echo "deploying 3tier app in realese mode..."
    - helm upgrade --install #TODO
  environment:
    # name: uat
    #OPTIONNAL on_stop: stop_env_uat
  tags:
  # TODO

#---------------------------------------------------

stop_env_uat:
  stage: destroy_if_needed
  image:
    name: #TODO
  variables:
    TYPE: "uat"
  script:
    - echo "Cleaning up review app"
    - helm uninstall #TODO
  when: manual
  environment:
    name: uat
    action: stop
  tags:
    #TODO

#---------------------------------------------------
